# -*- coding: utf-8 -*-
from setuphelpers import *
from setuphelpers_windows import *

# https://learn.microsoft.com/en-us/windows-hardware/drivers/storage/msft-physicaldisk

def install():
    pass

def audit():
    try:
        data_disk_type = get_disk_info()
    except Exception as e:
        data_host_info = {"status": str(e)}

    WAPT.write_audit_data_if_changed("physical_disks", "disks_info", data_disk_type)
    return "OK"

def get_disk_info():
    list_disk = []

    media_type_dict = {
        "0" : "Unspecified",
        "3" : "HDD",
        "4" : "SSD",
        "5" : "SCM"
        }

    health_status_dict = {
        "0" : "Healthy",
        "1" : "Warning",
        "2" : "Unhealthy",
        "5" : "Unknown"
        }

    try:
        objWMI = GetObject('winmgmts:\\\\.\\root\\Microsoft\\Windows\\Storage').InstancesOf('MSFT_PhysicalDisk')

        for obj in objWMI:
            dict_disk_info = {}
            dict_disk_info["FriendlyName"] = obj.FriendlyName
            dict_disk_info["MediaType"] = media_type_dict[str(obj.MediaType)] + f" ({obj.MediaType})"
            dict_disk_info["HealthStatus"] = health_status_dict[str(obj.HealthStatus)] + f" ({obj.HealthStatus})"
            dict_disk_info["FirmwareVersion"] = obj.FirmwareVersion

        list_disk.append(dict_disk_info)

    except:
        pass

    return list_disk
